diff -u --recursive --new-file isode-8.0/quipu/Makefile isode-8.0-linux/quipu/Makefile
--- isode-8.0/quipu/Makefile	Tue Jun 16 13:34:01 1992
+++ isode-8.0-linux/quipu/Makefile	Mon Aug 23 11:24:13 1993
@@ -37,8 +37,8 @@
 
 # Remove these two definitions if you do not want the QUIPU optimised malloc.
 # Performace may suffer if you do!
-MALLOC_C =	malloc.c
-MALLOC_O =	malloc.o
+#MALLOC_C =	malloc.c
+#MALLOC_O =	malloc.o
 #DEBUGLIB  =	/xtel/user/cjr/src/mprof/libc_mp.a
 
 ##############################################################
@@ -133,7 +133,7 @@
 		$(LDCC) $(LDFLAGS) -o $@ malloc_test.o qmalloc.o
 
 qmalloc.o:	malloc.c
-		$(CC) $(CFLAGS) -DMALLOC_TEST -o $@ -c malloc.c 
+		$(CC) $(CFLAGS) -o $@ -c malloc.c 
 
 quipuvrsn.c:	$(OFILES)
 		@$(UTILDIR)version.sh quipu > $@
diff -u --recursive --new-file isode-8.0/quipu/dish/Makefile isode-8.0-linux/quipu/dish/Makefile
--- isode-8.0/quipu/dish/Makefile	Tue Jun 16 13:35:40 1992
+++ isode-8.0-linux/quipu/dish/Makefile	Mon Aug 23 15:52:33 1993
@@ -78,6 +78,7 @@
 		-@echo ""
 
 dish:		xdish
+		:
 
 xdish:		libdish.a dish.o $(LIBES)
 		$(LDCC) $(LDFLAGS) -o $@ dish.o $(LIBDISH) \
diff -u --recursive --new-file isode-8.0/quipu/dish/dishlib.c isode-8.0-linux/quipu/dish/dishlib.c
--- isode-8.0/quipu/dish/dishlib.c	Tue Jun 16 13:35:46 1992
+++ isode-8.0-linux/quipu/dish/dishlib.c	Wed Jan  5 11:16:10 1994
@@ -160,9 +160,13 @@
 	(void) signal (SIGHUP,	dish_quit);
 	(void) signal (SIGQUIT,	dish_quit);
 	(void) signal (SIGILL, 	dish_quit);
+#ifdef SIGBUS
 	(void) signal (SIGBUS,	dish_quit);
+#endif
 	(void) signal (SIGSEGV,	dish_quit);
+#ifdef SIGSYS
 	(void) signal (SIGSYS,	dish_quit);
+#endif
 	(void) signal (SIGTERM,	dish_quit);
 
 #ifdef TURBO_DISK
diff -u --recursive --new-file isode-8.0/quipu/dish/fred.c isode-8.0-linux/quipu/dish/fred.c
--- isode-8.0/quipu/dish/fred.c	Tue Jun 16 13:35:49 1992
+++ isode-8.0-linux/quipu/dish/fred.c	Wed Jan  5 11:16:10 1994
@@ -137,7 +137,11 @@
 	if (argc != 3)
 	    goto usage;
 
+#ifdef _POSIX_SOURCE
+	(void) setenv ("DISPLAY", argv[2], 1);
+#else
 	(void) setenv ("DISPLAY", argv[2]);
+#endif
 	if (s_photo)
 	    set_av_pe_print (s_photo,
 			     strdup (isodefile ("g3fax/Xphoto", 1)));
@@ -1599,10 +1603,18 @@
 			}
 			ps_print (ps, " ");
 			*--ps -> ps_ptr = NULL, ps -> ps_cnt++;
+#ifdef _POSIX_SOURCE
+			(void) setenv ("RDN", ps -> ps_base, 1);
+#else
 			(void) setenv ("RDN", ps -> ps_base);
+#endif
 		    }
 		    else
+#ifdef _POSIX_SOURCE
+			(void) setenv ("RDN", "Photo", 1);
+#else
 			(void) setenv ("RDN", "Photo");
+#endif
 		}
 		break;
 	    }
diff -u --recursive --new-file isode-8.0/quipu/dish/modify.c isode-8.0-linux/quipu/dish/modify.c
--- isode-8.0/quipu/dish/modify.c	Tue Jun 16 13:35:52 1992
+++ isode-8.0-linux/quipu/dish/modify.c	Wed Jan  5 11:16:10 1994
@@ -81,6 +81,7 @@
 	DN		moddn;
 	char	       *home;
 	RDN		new_rdn;
+	char		force_del_draft = FALSE;
 
 struct  list_element   *start = 0 ;
 struct  list_element   *last ;
@@ -247,6 +248,16 @@
 	entry_ptr->e_attributes = get_attributes (fd);
 #endif
 
+	/* Fix ref count of all file attrs */
+	for (as = entry_ptr->e_attributes;as != NULLATTR; as = as->attr_link) {
+	   AV_Sequence avs;
+           for (avs = as->attr_value; avs != NULLAV; avs=avs->avseq_next)
+	       if (avs->avseq_av.av_syntax == AV_FILE) {
+		 ((struct file_syntax *)(avs->avseq_av.av_struct)) -> fs_ref++;
+		 force_del_draft = TRUE;
+	       }
+        }
+		
 	(void) fclose (fd);
 	if (parse_status != 0)
 		return;
@@ -354,6 +365,8 @@
 	while (ds_modifyentry (&mod_arg, &error) != DS_OK) {
 		if (dish_error (OPT, &error) == 0) {
 			entry_free (entry_ptr);
+			if (force_del_draft)
+				make_old (fname,draft_flag);
 			return;
 		}
 		mod_arg.mea_object = error.ERR_REFERRAL.DSE_ref_candidates->cr_name;
diff -u --recursive --new-file isode-8.0/quipu/dish/pipe.c isode-8.0-linux/quipu/dish/pipe.c
--- isode-8.0/quipu/dish/pipe.c	Tue Jun 16 13:35:55 1992
+++ isode-8.0-linux/quipu/dish/pipe.c	Wed Jan  5 11:16:09 1994
@@ -64,7 +64,11 @@
 
 	if ((cp = getenv ("DISHPARENT")) == NULLCP) {
 		(void) sprintf (parent, "%d", getppid ());
+#ifdef _POSIX_SOURCE
+		(void) setenv ("DISHPARENT", cp = parent, 1);
+#else
 		(void) setenv ("DISHPARENT", cp = parent);
+#endif
 	}
 
 
@@ -360,7 +364,11 @@
 #else
 		(void) sprintf (buffer, "127.0.0.1 %d", portno);
 #endif
+#ifdef _POSIX_SOURCE
+		(void) setenv ("DISHPROC", ptr = buffer, 1);
+#else
 		(void) setenv ("DISHPROC", ptr = buffer);
+#endif
 	}
 
 	if ((dp = index (ptr, ' ')) == NULLCP || sscanf (dp + 1, "%d", &portno) != 1) {
diff -u --recursive --new-file isode-8.0/quipu/ds_add.c isode-8.0-linux/quipu/ds_add.c
--- isode-8.0/quipu/ds_add.c	Tue Jun 16 13:34:08 1992
+++ isode-8.0-linux/quipu/ds_add.c	Wed Jan  5 11:16:11 1994
@@ -67,6 +67,9 @@
 int authp;
 extern int read_only;
 extern int	entry_cmp();
+char add_edbinfo = FALSE;
+Attr_Sequence newas;
+		
 
 	DLOG (log_dsap,LLOG_TRACE,("ds_add"));
 
@@ -204,6 +207,11 @@
 	ptr->e_name = rdn_cpy (dn->dn_rdn);
 	ptr->e_attributes = as_cpy (arg->ada_entry);
  
+	/* Add QUIPU object to object class -> may not be a QUIPU DUA ! */
+	newas = as_comp_new (AttrT_cpy(at_objectclass),
+		 str2avs(QUIPUOBJECT,at_objectclass),NULLACL_INFO);
+	ptr->e_attributes = as_merge (ptr->e_attributes,newas);
+
 	modify_attr (ptr,binddn);
 
 	DLOG (log_dsap,LLOG_TRACE,("add - unravel"));
@@ -260,8 +268,6 @@
 		/* Turn leaf into non leaf, and add child */
 		/* Temporary until managemnet tools do it */
 
-		Attr_Sequence newas;
-		
 		if (entryptr->e_data != E_DATA_MASTER) {
 			DN dn_found;
 			struct dn_seq	* dn_stack = NULLDNSEQ;
diff -u --recursive --new-file isode-8.0/quipu/ds_modify.c isode-8.0-linux/quipu/ds_modify.c
--- isode-8.0/quipu/ds_modify.c	Tue Jun 16 13:34:12 1992
+++ isode-8.0-linux/quipu/ds_modify.c	Wed Jan  5 11:16:11 1994
@@ -268,23 +268,6 @@
 		}
 	}
 
-	/* check the last value of an attribute has not been removed */
-	for (as = entryptr->e_attributes; as!=NULLATTR; as=as->attr_link)
-		if (as->attr_value == NULLAV) {
-			error->dse_type = DSE_ATTRIBUTEERROR;
-			error->ERR_ATTRIBUTE.DSE_at_name = 
-				get_copy_dn (entryptr);
-			error->ERR_ATTRIBUTE.DSE_at_plist.DSE_at_what =
-				DSE_AT_CONSTRAINTVIOLATION;
-			error->ERR_ATTRIBUTE.DSE_at_plist.DSE_at_type = 
-				AttrT_cpy (as->attr_type);
-			error->ERR_ATTRIBUTE.DSE_at_plist.DSE_at_value = 
-				NULLAttrV;
-			error->ERR_ATTRIBUTE.DSE_at_plist.dse_at_next = 
-				DSE_AT_NOPROBLEM;
-			entry_free (entryptr);
-			return (DS_ERROR_REMOTE);
-		}
 	
 	DATABASE_HEAP;
 	modify_attr (entryptr,binddn);
diff -u --recursive --new-file isode-8.0/quipu/ds_read.c isode-8.0-linux/quipu/ds_read.c
--- isode-8.0/quipu/ds_read.c	Tue Jun 16 13:34:14 1992
+++ isode-8.0-linux/quipu/ds_read.c	Wed Jan  5 11:16:11 1994
@@ -39,7 +39,7 @@
 Attr_Sequence dsa_eis_select ();
 extern Attr_Sequence entry_find_type();
 static cant_use_cache();
-static attribute_not_cached ();
+static attribute_not_cache ();
 extern AttributeType at_control;
 extern unsigned bind_policy;
 extern unsigned strong_policy;
@@ -254,7 +254,8 @@
 	if (dn == NULLDN) 
 		return FALSE;
 
-	if ((ptr->e_data == E_DATA_MASTER) || (ptr->e_data == E_TYPE_SLAVE))
+	if ((ptr->e_data == E_DATA_MASTER) || (ptr->e_data == E_TYPE_SLAVE) ||
+	    (ptr->e_complete == FALSE))
 		return FALSE;
 
 	/* see if more than cached data is required */	
diff -u --recursive --new-file isode-8.0/quipu/dsa.c isode-8.0-linux/quipu/dsa.c
--- isode-8.0/quipu/dsa.c	Tue Jun 16 13:34:19 1992
+++ isode-8.0-linux/quipu/dsa.c	Wed Jan  5 11:16:10 1994
@@ -281,9 +281,13 @@
     /* now started don't stop on core dumps !!! */
     (void) signal (SIGQUIT, attempt_restart);
     (void) signal (SIGILL,  attempt_restart);
+#ifdef SIGBUS
     (void) signal (SIGBUS,  attempt_restart);
+#endif
     (void) signal (SIGSEGV, attempt_restart);
+#ifdef SIGSYS
     (void) signal (SIGSYS,  attempt_restart);
+#endif
     (void) signal (SIGPIPE,  attempt_restart);
 #ifdef	SIGUSR1
     (void) signal (SIGUSR1, list_status);
@@ -743,9 +747,13 @@
 
 	(void) signal (SIGQUIT, attempt_restart);
 	(void) signal (SIGILL,  attempt_restart);
+#ifdef SIGBUS
 	(void) signal (SIGBUS,  attempt_restart);
+#endif
 	(void) signal (SIGSEGV, attempt_restart);
+#ifdef SIGSYS
 	(void) signal (SIGSYS,  attempt_restart);
+#endif
 
 	if (sig >= 0 && debug)
 		(void) fprintf (stderr,"DSA %s has a problem\n",mydsaname);
diff -u --recursive --new-file isode-8.0/quipu/dsp_cache.c isode-8.0-linux/quipu/dsp_cache.c
--- isode-8.0/quipu/dsp_cache.c	Wed Jun 17 08:23:55 1992
+++ isode-8.0-linux/quipu/dsp_cache.c	Wed Jul 13 17:10:23 1994
@@ -43,8 +43,9 @@
 extern AttributeType at_acl;
 extern AttributeType at_objectclass;
 
-Entry cache_dsp_entry (ptr)
+Entry cache_dsp_entry (ptr,complete)
 EntryInfo      *ptr;
+char complete;
 {
 	/* assumes entry passed is complete */
 
@@ -89,7 +90,7 @@
 			as_free (eptr->e_attributes);
 			as_write_files(ptr->ent_attr,edbtmp_path);
 			eptr->e_attributes = as_cpy(ptr->ent_attr);
-			eptr->e_complete = TRUE;
+			eptr->e_complete = complete;
 			eptr->e_data = E_TYPE_CACHE_FROM_MASTER;
 			eptr->e_age = timenow;
 			if (eptr->e_inherit)
@@ -103,7 +104,7 @@
 			return NULLENTRY;
 		local_cache_size++;
 		eptr->e_name = rdn_cpy (dnptr->dn_rdn);
-		eptr->e_complete = TRUE;
+		eptr->e_complete = complete;
 		eptr->e_data = E_TYPE_CACHE_FROM_MASTER;
 		as_write_files(ptr->ent_attr,edbtmp_path);
 		eptr->e_attributes = as_cpy(ptr->ent_attr);
@@ -153,10 +154,11 @@
 EntryInfo *ptr;
 Entry entryptr;
 Attr_Sequence as, eis_select (), attr_eis_select ();
+char cache_search = FALSE;
 
     switch(arg->arg_type) {    
     case OP_READ:
-	entryptr = cache_dsp_entry (&res->res_rd.rdr_entry);
+	entryptr = cache_dsp_entry (&res->res_rd.rdr_entry,TRUE);
 	if (ctx == DS_CTX_X500_DAP)
 	   if (entryptr != NULLENTRY) {
 	    
@@ -182,8 +184,12 @@
 	   }
 	break;
     case OP_SEARCH:
+        if ((arg->arg_sr.sra_eis.eis_allattributes == TRUE) &&
+            (arg->arg_sr.sra_eis.eis_infotypes == EIS_ATTRIBUTESANDVALUES)) 
+		cache_search = TRUE;
+
 	for (ptr = res->res_sr.CSR_entries; ptr != NULLENTRYINFO; ptr = ptr->ent_next) 
- 			(void) cache_dsp_entry (ptr);
+ 			(void) cache_dsp_entry (ptr,cache_search);
      	break;
     case OP_LIST:
 	if (ctx == DS_CTX_QUIPU_DSP)
diff -u --recursive --new-file isode-8.0/quipu/entry_load.c isode-8.0-linux/quipu/entry_load.c
--- isode-8.0/quipu/entry_load.c	Tue Jun 16 13:34:27 1992
+++ isode-8.0-linux/quipu/entry_load.c	Wed Jan  5 11:16:11 1994
@@ -198,8 +198,9 @@
         free (cp);
 
         nptr = (aps->ps_base + strlen (mapdir));
-        aps->ps_ptr = nptr;
 #endif /* TEMPNAM */
+
+	aps->ps_ptr = aps->ps_base + strlen(aps->ps_base);
 
 	DLOG(log_dsap,LLOG_DEBUG,("mapped name %s",aps->ps_base));
 
diff -u --recursive --new-file isode-8.0/quipu/get_dsa_info.c isode-8.0-linux/quipu/get_dsa_info.c
--- isode-8.0/quipu/get_dsa_info.c	Tue Jun 16 13:34:30 1992
+++ isode-8.0-linux/quipu/get_dsa_info.c	Wed Jan  5 11:16:11 1994
@@ -235,7 +235,7 @@
     */
 
     ent_res = &(on->on_resp.di_result.dr_res.dcr_dsres.res_rd.rdr_entry);
-    if((di_ent = cache_dsp_entry (ent_res)) == NULLENTRY)
+    if((di_ent = cache_dsp_entry (ent_res,TRUE)) == NULLENTRY)
     {
 	pslog (log_dsap,LLOG_EXCEPTIONS,
 	       "dsa_info_result_wakeup - cache_dsp_entry failure",
diff -u --recursive --new-file isode-8.0/quipu/malloc.c isode-8.0-linux/quipu/malloc.c
--- isode-8.0/quipu/malloc.c	Tue Jun 16 13:34:31 1992
+++ isode-8.0-linux/quipu/malloc.c	Wed Jan  5 11:16:11 1994
@@ -1,3 +1,5 @@
+#ifndef __linux__
+
 /* malloc.c - Quipu DSA specific memory management */
 
 #ifndef	lint
@@ -804,3 +806,5 @@
 }
 
 #endif	/* QUIPUMALLOC */
+
+#endif /* __linux__ */
diff -u --recursive --new-file isode-8.0/quipu/oper_result.c isode-8.0-linux/quipu/oper_result.c
--- isode-8.0/quipu/oper_result.c	Tue Jun 16 13:34:39 1992
+++ isode-8.0-linux/quipu/oper_result.c	Wed Jan  5 11:16:11 1994
@@ -73,7 +73,7 @@
 
 	/* If we have the arguments we could do more caching here. */
 	if (dr->dr_res.dcr_dsres.result_type == OP_READ)
-	       (void) cache_dsp_entry (&dr->dr_res.dcr_dsres.res_rd.rdr_entry);
+	       (void) cache_dsp_entry (&dr->dr_res.dcr_dsres.res_rd.rdr_entry,TRUE);
 
 	ds_res_free (&dr->dr_res.dcr_dsres);
 	oper_extract(on);
diff -u --recursive --new-file isode-8.0/quipu/schema.c isode-8.0-linux/quipu/schema.c
--- isode-8.0/quipu/schema.c	Tue Jun 16 13:34:47 1992
+++ isode-8.0-linux/quipu/schema.c	Wed Jan  5 11:16:12 1994
@@ -108,6 +108,23 @@
 		}
 	}
 
+	/* check the each attribute has at least one value */
+	for (at = eptr->e_attributes; at!=NULLATTR; at=at->attr_link)
+		if (at->attr_value == NULLAV) {
+			error->dse_type = DSE_ATTRIBUTEERROR;
+			error->ERR_ATTRIBUTE.DSE_at_name = 
+				get_copy_dn (eptr);
+			error->ERR_ATTRIBUTE.DSE_at_plist.DSE_at_what =
+				DSE_AT_CONSTRAINTVIOLATION;
+			error->ERR_ATTRIBUTE.DSE_at_plist.DSE_at_type = 
+				AttrT_cpy (at->attr_type);
+			error->ERR_ATTRIBUTE.DSE_at_plist.DSE_at_value = 
+				NULLAttrV;
+			error->ERR_ATTRIBUTE.DSE_at_plist.dse_at_next = 
+				DSE_AT_NOPROBLEM;
+			return (DS_ERROR_REMOTE);
+		}
+
 	/* now check 'must contain' attributes */
 	for (; avs != NULLAV; avs = avs->avseq_next) {
 	    oc = (objectclass *) avs->avseq_av.av_struct;
diff -u --recursive --new-file isode-8.0/quipu/sys_init.c isode-8.0-linux/quipu/sys_init.c
--- isode-8.0/quipu/sys_init.c	Tue Jun 16 13:34:54 1992
+++ isode-8.0-linux/quipu/sys_init.c	Mon Jan 17 10:37:58 1994
@@ -107,7 +107,7 @@
 	    && ((statbuf.st_mode & S_IFMT) == S_IFDIR)) {
 		    /* tmpdir exists - clean it */
 		struct dirent **namelist;
-		(void) _scandir(edbtmp_buf, &namelist, rmFiles, NULLIFP);
+		(void) scandir(edbtmp_buf, &namelist, rmFiles, NULLIFP);
 		if (namelist)
 		    free((char *) namelist);
 
diff -u --recursive --new-file isode-8.0/quipu/update.c isode-8.0-linux/quipu/update.c
--- isode-8.0/quipu/update.c	Tue Jun 16 13:35:12 1992
+++ isode-8.0-linux/quipu/update.c	Wed Jan  5 11:16:12 1994
@@ -65,6 +65,24 @@
 static edb_start ();
 static edb_continue ();
 
+#ifdef USE_DSA_WAIT
+
+/*
+dsa_wait() causes problems sometimes -> it is not re-entrant.
+If the connection we are serving fails, then we free the oper struct
+we are currently using.
+Easiest solution is to remove the dsa_wait() calls.
+But eventually need to work out	how to put them back.  Without then the 
+blocking during an EDB update will be worse.
+
+Also need to look as dsa_wait() calls in ds_search().
+
+*/
+
+
+#endif
+
+
 char * edbtmp_path = NULLCP;
 
 #ifndef TURBO_DISK
@@ -411,8 +429,9 @@
 		if(dn || isroot)
 		    break;
 
+#ifdef USE_DSA_WAIT
 		(void) dsa_wait (0);	/* accept any results of previous ops */
-
+#endif
 	}
 	avs_free (avs_head);
 
@@ -702,8 +721,9 @@
 	}
 
 
+#ifdef USE_DSA_WAIT
 	(void) dsa_wait (0);	/* progress any other connections before writing EDB */
-
+#endif
 	if (eptr->e_children == NULLAVL)
 		slave_edbs++;
 
@@ -916,8 +936,9 @@
 	}
 
 	/* This is a slow process, take a look at the network... */
+#ifdef USE_DSA_WAIT
 	(void) dsa_wait (0);
-
+#endif
 	/* write PE to file */
 
 	/* Make file name - this is where we could be clever an pick up
@@ -1010,7 +1031,9 @@
 	edbops = nextop;
 
 	/* This is a slow process, take a look at the network... */
+#ifdef USE_DSA_WAIT
 	(void) dsa_wait (0);
+#endif
 
 	pe_free (pe);
 
@@ -1284,7 +1307,9 @@
 
 	pe_free(pe);
 
+#ifdef USE_DSA_WAIT
 	(void) dsa_wait (0);	/* accept any results of previous ops */
+#endif
 
 	return TRUE;
 }
diff -u --recursive --new-file isode-8.0/ronot/Makefile isode-8.0-linux/ronot/Makefile
--- isode-8.0/ronot/Makefile	Tue Jun 16 13:36:37 1992
+++ isode-8.0-linux/ronot/Makefile	Tue Aug 24 11:51:28 1993
@@ -59,6 +59,18 @@
 
 inst-libronot:	$(LIBDIR)libronot.a $(LINTDIR)llib-lronot
 
+zap-ronot:
+		-rm -f $(OFILES) libronot.a ronotvrsn.o
+
+linux-lib:	zap-ronot ../jump/libronot.a
+
+../jump/libronot.a:	libronot.a
+		-rm -f $@
+		cp libronot.a $@
+		@$(UTILDIR)make-lib.sh $(SYSTEM) $@ -ranlib
+		-@ls -gls $@
+		-@echo ""
+
 $(LIBDIR)libronot.a:	libronot.a
 		-rm -f $@
 		cp libronot.a $@
diff -u --recursive --new-file isode-8.0/rosap/Makefile isode-8.0-linux/rosap/Makefile
--- isode-8.0/rosap/Makefile	Tue Jun 16 13:37:02 1992
+++ isode-8.0-linux/rosap/Makefile	Wed Aug 25 14:14:43 1993
@@ -78,6 +78,18 @@
 
 inst-librosap:	$(LIBDIR)librosap.a $(LINTDIR)llib-lrosap
 
+zap-rosap:
+		-rm -f $(OFILES) librosap.a ROS_tables.o rosapvrsn.o
+
+linux-lib:	zap-rosap ../jump/librosap.a
+
+../jump/librosap.a:	librosap.a
+		-rm -f $@
+		cp librosap.a $@
+		@$(UTILDIR)make-lib.sh $(SYSTEM) $@ -ranlib
+		-@ls -gls $@
+		-@echo ""
+
 $(LIBDIR)librosap.a:	librosap.a
 		-rm -f $@
 		cp librosap.a $@
diff -u --recursive --new-file isode-8.0/rosy/Makefile isode-8.0-linux/rosy/Makefile
--- isode-8.0/rosy/Makefile	Tue Jun 16 13:37:29 1992
+++ isode-8.0-linux/rosy/Makefile	Tue Aug 24 11:51:15 1993
@@ -69,6 +69,7 @@
 		-@echo ""
 
 rosy:		xrosy
+		:
 
 xrosy:		rosyvrsn.o $(PEPYLIBES)
 		$(LDCC) $(LDFLAGS) -o $@ rosy.o yacc.o pepy_misc.o \
@@ -133,6 +134,18 @@
 OFILES=		$(P-OFILES) $(N-OFILES) $(OSTRINGS)
 
 inst-librosy:	$(LIBDIR)librosy.a $(LINTDIR)llib-lrosy
+
+zap-rosy:
+		-rm -f $(OFILES) librosy.a
+
+linux-lib:	zap-rosy ../jump/librosy.a
+
+../jump/librosy.a:	librosy.a
+		-rm -f $@
+		cp librosy.a $@
+		@$(UTILDIR)make-lib.sh $(SYSTEM) $@ -ranlib
+		-@ls -gls $@
+		-@echo ""
 
 $(LIBDIR)librosy.a:	librosy.a
 		-rm -f $@
diff -u --recursive --new-file isode-8.0/rosy/rosy.c isode-8.0-linux/rosy/rosy.c
--- isode-8.0/rosy/rosy.c	Tue Jun 16 13:37:31 1992
+++ isode-8.0-linux/rosy/rosy.c	Wed Mar  9 15:50:12 1994
@@ -772,8 +772,8 @@
 
     (void) fflush (stdout);
     (void) fflush (fdef);
-    (void) fclose (ftbl);
-    (void) fclose (fstb);
+    (void) fflush (ftbl);
+    (void) fflush (fstb);
 
     if (ferror (stdout) || ferror (fdef) || ferror (ftbl) || ferror (fstb))
 	myyerror ("write error - %s", sys_errname (errno));
diff -u --recursive --new-file isode-8.0/rtsap/Makefile isode-8.0-linux/rtsap/Makefile
--- isode-8.0/rtsap/Makefile	Tue Jun 16 13:37:45 1992
+++ isode-8.0-linux/rtsap/Makefile	Tue Aug 24 11:51:56 1993
@@ -73,6 +73,18 @@
 
 inst-librtsap:	$(LIBDIR)librtsap.a $(LINTDIR)llib-lrtsap
 
+zap-rtsap:
+		-rm -f $(OFILES) librtsap.a RTS_tables.o rtsapvrsn.o
+
+linux-lib:	zap-rtsap ../jump/librtsap.a
+
+../jump/librtsap.a:	librtsap.a
+		-rm -f $@
+		cp librtsap.a $@
+		@$(UTILDIR)make-lib.sh $(SYSTEM) $@ -ranlib
+		-@ls -gls $@
+		-@echo ""
+
 $(LIBDIR)librtsap.a:	librtsap.a
 		-rm -f $@
 		cp librtsap.a $@
diff -u --recursive --new-file isode-8.0/ssap/Makefile isode-8.0-linux/ssap/Makefile
--- isode-8.0/ssap/Makefile	Tue Jun 16 13:39:41 1992
+++ isode-8.0-linux/ssap/Makefile	Tue Aug 24 11:53:19 1993
@@ -66,6 +66,18 @@
 
 inst-libssap:	$(LIBDIR)libssap.a $(LINTDIR)llib-lssap
 
+zap-ssap:
+		-rm -f $(OFILES) libssap.a ssapvrsn.o
+
+linux-lib:	zap-ssap ../jump/libssap.a
+
+../jump/libssap.a:	libssap.a
+		-rm -f $@
+		cp libssap.a $@
+		@$(UTILDIR)make-lib.sh $(SYSTEM) $@ -ranlib
+		-@ls -gls $@
+		-@echo ""
+
 $(LIBDIR)libssap.a:	libssap.a
 		-rm -f $@
 		cp libssap.a $@
diff -u --recursive --new-file isode-8.0/support/isore.c isode-8.0-linux/support/isore.c
--- isode-8.0/support/isore.c	Tue Jun 16 13:40:16 1992
+++ isode-8.0-linux/support/isore.c	Wed Jan  5 11:16:18 1994
@@ -30,6 +30,10 @@
 #include "general.h"
 #include "manifest.h"
 
+#ifndef SIGEMT
+#define SIGEMT	SIGUSR1
+#endif
+
 /*    MAIN */
 
 static SFD	EMTser ();
diff -u --recursive --new-file isode-8.0/support/tsapd.c isode-8.0-linux/support/tsapd.c
--- isode-8.0/support/tsapd.c	Tue Jun 16 13:40:21 1992
+++ isode-8.0-linux/support/tsapd.c	Wed Jul 13 17:10:03 1994
@@ -332,9 +332,18 @@
 		== NULL) {
 #else
     for (is = iae; is < iz; is++)
+	
+#if 0
+	/* THIS doesn't work - JPO */
 	if (tsap_addr_cmp (&is -> is_addr, &ts -> ts_called) == OK)
 	    break;
-
+#else
+        if (is -> is_addr.ta_selectlen == ts -> ts_called.ta_selectlen
+	    && bcmp (is -> is_addr.ta_selector,
+		     ts -> ts_called.ta_selector,
+		     is -> is_addr.ta_selectlen) == 0)
+	    break;
+#endif
     if (is >= iz) {
 #endif
 	    (void) sprintf (buffer, "OSI service tsap/%s not found",
diff -u --recursive --new-file isode-8.0/tsap/Makefile isode-8.0-linux/tsap/Makefile
--- isode-8.0/tsap/Makefile	Tue Jun 16 13:40:41 1992
+++ isode-8.0-linux/tsap/Makefile	Tue Aug 24 11:53:31 1993
@@ -63,6 +63,18 @@
 
 inst-libtsap:	$(LIBDIR)libtsap.a $(LINTDIR)llib-ltsap
 
+zap-tsap:
+		-rm -f $(OFILES) libtsap.a tsapvrsn.o
+
+linux-lib:	zap-tsap ../jump/libtsap.a
+
+../jump/libtsap.a:	libtsap.a
+		-rm -f $@
+		cp libtsap.a $@
+		@$(UTILDIR)make-lib.sh $(SYSTEM) $@ -ranlib
+		-@ls -gls $@
+		-@echo ""
+
 $(LIBDIR)libtsap.a:	libtsap.a
 		-rm -f $@
 		cp libtsap.a $@
diff -u --recursive --new-file isode-8.0/tsap/tp0ts.c isode-8.0-linux/tsap/tp0ts.c
--- isode-8.0/tsap/tp0ts.c	Tue Jun 16 13:40:44 1992
+++ isode-8.0-linux/tsap/tp0ts.c	Wed Jan  5 11:16:18 1994
@@ -1041,8 +1041,10 @@
 	        != qb -> qb_len) {
 	    if (nc == NOTOK) {
 		if (errno != EWOULDBLOCK) {
-		    result = tsaplose (td, DR_NETWORK, "failed",
-				      "write to network");
+		    (void) tpktlose (tb, td, DR_NETWORK, "failed",
+			"write to network");
+		    result = NOTOK;
+
 		    goto out;
 		}
 
diff -u --recursive --new-file isode-8.0/tsap/ts2tcp.c isode-8.0-linux/tsap/ts2tcp.c
--- isode-8.0/tsap/ts2tcp.c	Tue Jun 16 13:40:45 1992
+++ isode-8.0-linux/tsap/ts2tcp.c	Wed Jan  5 11:16:18 1994
@@ -37,7 +37,7 @@
 #ifdef	BSD42
 #include <sys/ioctl.h>
 #endif
-#ifdef	SYS5
+#if defined(SYS5) || defined(__linux__)
 #include <fcntl.h>
 #endif
 
diff -u --recursive --new-file isode-8.0/tsap/tsaprovider.c isode-8.0-linux/tsap/tsaprovider.c
--- isode-8.0/tsap/tsaprovider.c	Tue Jun 16 13:40:51 1992
+++ isode-8.0-linux/tsap/tsaprovider.c	Wed Jan  5 11:16:18 1994
@@ -36,6 +36,9 @@
 #include "sys.file.h"
 #include <sys/stat.h>
 
+#ifdef __linux__
+#include <linux/sockios.h>
+#endif
 
 #define	selmask(fd,m,n) \
 { \
@@ -421,7 +424,7 @@
     register struct TSAPdisconnect *td = &tds;
 
 #ifndef	BSDSIGS
-    (void) signal (SIGEMT, DATAser);
+    (void) signal (_SIGIO, DATAser);
 
     smask = sigioblock ();
 #endif
@@ -472,7 +475,7 @@
     }
 
 #ifndef	SIGPOLL
-    (void) kill (TPid, SIGEMT);
+    (void) kill (TPid, _SIGIO);
 #endif
 
 #ifndef	BSDSIGS
@@ -514,10 +517,10 @@
 	return tsaplose (td, DR_CONGEST, NULLCP, "you lose");
     if (!inited) {
 #ifndef	BSDSIGS
-	int    smask = sigsetmask (sigblock (0) & ~sigmask (SIGEMT));
+	int    smask = sigsetmask (sigblock (0) & ~sigmask (_SIGIO));
 #endif
 
-	(void) signal (SIGEMT, DATAser);
+	(void) signal (_SIGIO, DATAser);
 #ifndef	BSDSIGS
 	(void) sigiomask (smask);
 #endif
@@ -542,7 +545,7 @@
 		continue;
 
 	    case OK: 
-		(void) signal (SIGEMT, SIG_DFL);
+		(void) signal (_SIGIO, SIG_DFL);
 		(void) execv (*is -> is_vec, is -> is_vec);
 		_exit (1);
 
diff -u --recursive --new-file isode-8.0/util/make-lib.sh isode-8.0-linux/util/make-lib.sh
--- isode-8.0/util/make-lib.sh	Tue Jun 16 11:12:10 1992
+++ isode-8.0-linux/util/make-lib.sh	Mon Jul  4 13:06:14 1994
@@ -1,6 +1,6 @@
 : run this script through /bin/sh
 
-M=BSD42 L= O= S= Q= SHD= MAJ= MIN= LD=ld
+M=BSD42 L= O= S= Q= SHD= MAJ= MIN= #LD=ld
 
 while [ $# -gt 0 ]
 do
diff -u --recursive --new-file isode-8.0/util/version.sh isode-8.0-linux/util/version.sh
--- isode-8.0/util/version.sh	Tue Jun 16 11:12:10 1992
+++ isode-8.0-linux/util/version.sh	Thu Aug 19 15:39:29 1993
@@ -1,7 +1,7 @@
 : run this script through /bin/sh
 
 : this hacks past a bug in make...
-exec 3<&- 4<&- 5<&- 6<&- 7<&-
+#exec 3<&- 4<&- 5<&- 6<&- 7<&-
 
 OFS="$IFS" IFS=:
 
diff -u --recursive --new-file isode-8.0/vt/Makefile isode-8.0-linux/vt/Makefile
--- isode-8.0/vt/Makefile	Tue Jun 16 13:41:09 1992
+++ isode-8.0-linux/vt/Makefile	Mon Aug 23 15:16:14 1993
@@ -74,6 +74,7 @@
 		-@echo ""
 
 vtd:		xvtd
+		:
 
 xvtd:		vtd.o $(OFILES) libvt.a $(LIBES)
 		$(LDCC) $(LDFLAGS) -o $@ vtd.o $(OFILES) libvt.a \
@@ -108,6 +109,7 @@
 		-@echo ""
 
 vt:		xvt
+		:
 
 xvt:		vt.o $(OFILES) libvt.a $(LIBES)
 		$(LDCC) $(LDFLAGS) -o $@ vt.o $(OFILES) libvt.a \
diff -u --recursive --new-file isode-8.0/vt/map.c isode-8.0-linux/vt/map.c
--- isode-8.0/vt/map.c	Tue Jun 16 13:41:11 1992
+++ isode-8.0-linux/vt/map.c	Wed Jan  5 11:16:19 1994
@@ -37,7 +37,12 @@
 #include <sys/ioctl.h>
 #endif
 #ifdef TERMIOS
+#ifdef __linux__
+#include <termios.h>
+#include <unistd.h>
+#else
 #include <sys/termios.h>
+#endif
 #endif
 #include <fcntl.h>
 
diff -u --recursive --new-file isode-8.0/vt/vt.c isode-8.0-linux/vt/vt.c
--- isode-8.0/vt/vt.c	Tue Jun 16 13:41:20 1992
+++ isode-8.0-linux/vt/vt.c	Tue Jul 12 11:42:21 1994
@@ -34,8 +34,12 @@
 #include <sys/ioctl.h>
 #endif
 #ifdef TERMIOS
+#ifdef __linux__
+#include <termios.h>
+#else
 #include <sys/termios.h>
 #endif
+#endif
 #include <ctype.h>
 #include <setjmp.h>
 #include <varargs.h>
@@ -1275,10 +1279,7 @@
 	    	fd_set    ibits, obits;
 
 		FD_ZERO (&ibits);
-
 		FD_ZERO (&obits);
-		FD_SET (tout, &obits);
-		FD_SET (s, &obits);
 
 		if (nfrontp - nbackp)
 		    FD_SET (s, &obits);
diff -u --recursive --new-file isode-8.0/vt/vtd.c isode-8.0-linux/vt/vtd.c
--- isode-8.0/vt/vtd.c	Tue Jun 16 13:41:21 1992
+++ isode-8.0-linux/vt/vtd.c	Mon Jul 11 10:39:30 1994
@@ -36,7 +36,12 @@
 #include <sys/ioctl.h>
 #endif
 #ifdef	TERMIOS
+#ifdef __linux__
+#include <termios.h>
+#include <unistd.h>
+#else
 #include <sys/termios.h>
+#endif
 #ifdef BSD44
 #include <sys/ttydefaults.h>
 #include <sys/stat.h>
@@ -61,13 +66,17 @@
 #include <varargs.h>
 
 #define	BELL	'\07'
-#ifndef	SUNOS4
-#define BANNER	"\r\n\r\n4.2 BSD UNIX (%s)\r\n\r\n\r%s"
-#else
+#ifdef	SUNOS4
 #define BANNER	"\r\n\r\nSunOS UNIX (%s)\r\n\r\n\r%s"
+#else
+#ifdef __linux__
+#define BANNER	"\r\n\r\nLinux (%s)\r\n\r\n\r%s"
+#else
+#define BANNER	"\r\n\r\n4.2 BSD UNIX (%s)\r\n\r\n\r%s"
 #endif
+#endif
 
-#if !defined(SYS5) && !defined(BSD44) && !defined(_AIX)
+#if !defined(SYS5) && !defined(BSD44) && !defined(_AIX) && !defined(__linux__)
 void	vhangup();
 #endif
 
@@ -199,7 +208,7 @@
 	}
 	else
 		exit(1);
-#ifdef TERMIOS
+#if defined(TERMIOS) && !defined(__linux__)
 	na_image = 0;
 	nego_state = 0;			/*Start off in Local echo*/
 	i = forkpty(&p, line, NULL, NULL);
@@ -231,6 +240,9 @@
 gotpty:
 
 	cp[strlen("/dev/")] = 't';
+#ifdef __linux__
+	setsid();
+#else
 	t = open("/dev/tty", 2);
 	if (t >= 0) {
 		if (ioctl(t, TIOCNOTTY, 0) == -1) {
@@ -238,9 +250,11 @@
 		}
 		(void)close(t);
 	}
+#endif
 	t = open(cp, 2);
 	if (t < 0)
 		fatalperror(f, cp, errno);
+#ifndef TERMIOS
 	if (ioctl(t, TIOCGETP, (char*)&b) == -1) {
 		perror("ioctl (TIOCGETP)");
 		adios(NULLCP, "ioctl failed (TIOCGETP)");
@@ -262,6 +276,7 @@
 		perror("ioctl (TIOCSETP)");
 		adios(NULLCP, "ioctl failed (TIOCSETP)");
 	}
+#endif
 	na_image = 0;
 	nego_state = 0;			/*Start off in Local echo*/
 
